import { Team } from "../../core/Team";
import { FETCH_TEAMS, ADD_TEAM } from "../Constants";

export const setTeamsList = (teamsList: Team[]) => {
    return {
        type: FETCH_TEAMS,
        payload: teamsList,
    };
}

export const addNewTeam = (newTeam: Team) => {
    return async dispatch => {
        try {
            const response = await fetch('https://codefirst.iut.uca.fr/containers/enzojolys-r-dash_container/Ecuries', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json'
                },
                body: JSON.stringify(newTeam)
            });
            const team = await response.json();
            dispatch({
                type: ADD_TEAM,
                payload: team
            });
        } catch (error) {
            console.log('Error---------', error);
            //dispatch(fetchDataRejected(error))
        }
    }
}

export const getTeamsList = () => {
    return async dispatch => {
        try {
            const teamsPromise = await fetch('https://codefirst.iut.uca.fr/containers/enzojolys-r-dash_container/Ecuries');
            const teamsListJson = await teamsPromise.json();
            const teamsList: Team[] = teamsListJson.map(elt => new Team(elt["name"], elt["owner"], elt["users"], elt["logo"]));
            dispatch(setTeamsList(teamsList));
        } catch (error) {
            console.log('Error---------', error);
            //dispatch(fetchDataRejected(error))
        }
    }
} 